/* This code is GPL'ed !! See LICENSE
 * This file contains explosion-handling routines
 */
#include "hdr.h"

void addexpl(plansza* pla, int y, int x, int what)
{
	if(pla->lastExpl->valid == 1) /* 1 = invalid */
	{
		pla->lastExpl->y = y;
		pla->lastExpl->x = x;
		pla->lastExpl->valid = 0; /* it's new and undisplayed! */
		pla->lastExpl->what = what;
		if(pla->lastExpl->next != NULL)
			pla->lastExpl = pla->lastExpl->next;
	}
	else
	{
		pla->lastExpl->next = (explosion*) malloc(sizeof(explosion));
		pla->lastExpl = pla->lastExpl->next;
		pla->lastExpl->y = y;
		pla->lastExpl->x = x;
		pla->lastExpl->what = what;
		pla->lastExpl->valid = 0;
		pla->lastExpl->next = NULL;
	}
}

void showExplosions(plansza* pla)
{
	int i;
	int j;
	explosion* myExpl = pla->listOfExpls; 
		
	while(myExpl != NULL && myExpl->valid == 0)
	{
		for(i = -1; i <= 1; i++)
			for(j = -1; j <= 1; j++)
			{
				pla->tab[myExpl->y+i][myExpl->x+j] = IS_EXPLOSION;
				mvaddch(myExpl->y+i, myExpl->x+j, IS_EXPLOSION);
			}
		myExpl = myExpl->next; /* we get the next explosion */
	}
	
	myExpl = pla->listOfExpls;
	pla->listOfExpls = pla->shownExpls; /* swap the lists... */
	pla->lastExpl = pla->shownExpls;
	pla->shownExpls = myExpl; 
}

void delExplosions(plansza* pla)
{
	int i;
	int j;
	explosion* myExpl = pla->shownExpls; /* we get the first explosion... */
	
	while(myExpl != NULL && myExpl->valid == 0)
	{
		for(i = -1; i <= 1; i++)
			for(j = -1; j <= 1; j++)
			{	
				if(myExpl->what == IS_GEM || myExpl->what == IS_STONE)
				{/* we must create gravitable descriptor */
					pla->tabOfGravs[pla->createdGravs].numer = pla->createdGravs;
					pla->gravitables[myExpl->y+i][myExpl->x+j] = pla->createdGravs;
					pla->tabOfGravs[pla->createdGravs].ruch = 1; /* is not marked for moving */
					pla->tabOfGravs[pla->createdGravs].zabija = 1; /* don't kill */
					pla->tabOfGravs[pla->createdGravs].x = myExpl->x+j;
					pla->tabOfGravs[pla->createdGravs].y = myExpl->y+i;
					pla->createdGravs++;
				}
				pla->tab[myExpl->y+i][myExpl->x+j] = myExpl->what;
				mvaddch(myExpl->y+i, myExpl->x+j, myExpl->what);
			}
		myExpl->valid = 1; /* invalidate this explosion */
		myExpl = myExpl->next; /* we get the next explosion */
	}
}

void freeExplosions(plansza* pla)
{
	explosion* myExpl;
	
	myExpl = pla->listOfExpls;
	while(myExpl != NULL)
	{
		pla->lastExpl = myExpl;
		myExpl = myExpl->next;
		free(pla->lastExpl);
	}
	
	myExpl = pla->shownExpls;
	while(myExpl != NULL)
	{
		pla->lastExpl = myExpl;
		myExpl = myExpl->next;
		free(pla->lastExpl);
	}
}
