/* This code is GPL'ed !! See LICENSE */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <ncurses.h>

/* definicje zwiazane z kolorami */
#define SCIANA 1
#define LUDEK 2
#define BOMBA 3
#define NAGRODA 4
#define OUT 5
#define TLO 6
#define BUM 7
#define DIRT 8
/* jako #define, bo choc to niewydajne, zajmuje malo na wydruku kodu ;) */
#define IS_DIRT (ACS_CKBOARD | COLOR_PAIR(DIRT) | A_DIM)
#define IS_STONE ((int)ZNAK_BOMBY | COLOR_PAIR(BOMBA) | A_BOLD)
#define IS_PLAYER ((int)'o' | COLOR_PAIR(LUDEK) | A_BOLD)
#define IS_SPACE ((int)' ' | COLOR_PAIR(TLO))
#define IS_GEM (ACS_BULLET | COLOR_PAIR(NAGRODA) | A_BOLD)
//#define IS_GEM ((int)'*' | COLOR_PAIR(NAGRODA) | A_BOLD)
#define IS_EXPLOSION ((int)'*' | COLOR_PAIR(BUM) | A_BOLD)
#define IS_EXIT ((int)'A' | COLOR_PAIR(OUT) | A_BOLD)
#define IS_EXITED ((int)'A' | COLOR_PAIR(LUDEK) | A_BOLD)
#define IS_BIRD ((int)'#' | COLOR_PAIR(BOMBA) | A_BOLD)
/* jaka literka to bomba */
#define ZNAK_BOMBY '!'
#define ILECZEKAC 100000000
#define PAUZAPOSMIERCI 30

struct timespec czekaj; /* global structure for game speed */
struct timespec shortwait; /* Needed if lags are long, search code */

struct Gravitable;
typedef struct Gravitable gravitable;
struct Ludek;
typedef struct Ludek ludek;
struct Explosion;
typedef struct Explosion explosion;
struct Birds;
typedef struct Birds birds;

typedef struct Plansza 
{
	int tab[24][80]; /* znaki do wyswietlenia na planszy */
	int gravitables[24][80]; /* address in tabOfGravs */
	short int direction; /* 1 = right, -1 = left. used when falling left or right*/
	short int gameflow; /*0 = next level, 1 = DEFAULT! repeat level, -1 = end game*/
	short int howMuchToEat; /* how much gems to collect to go */
	short int lives;
	short int curlvl;
	short int numOfBirds;
	int numOfGravs;
	int createdGravs; /* numOfGravs include non existent gravs such as born from birds. */
	
	explosion* listOfExpls; /* list of created Explosions */
	explosion* shownExpls;/* list of Explosions shown in cuurent cycle and marked to clean in the next :) */
	explosion* lastExpl; /* pointer to the last explosion (for performance) */
	
	short int mainloopAsleep; /* 1 = not asleep, 0 = asleep, -1 = DIE BITCHES!, -2 = don't exist */
	
	gravitable* tabOfGravs; /* table of gravitables. gravitable = gem or stone or bomb */
	short int gravityAsleep; /* 1 = not asleep, 0 = asleep, -1 = DIE BITCHES!, -2 = don't exist */
	
	birds* tabOfBirds;
	
	ludek* gracz;
	short int playerAsleep; /* 1 = not asleep, 0 = asleep, -1 = DIE BITCHES!, -2 = don't exist */
} plansza;

struct Gravitable /* deskryptor bomby. bombowo! :) */
{
	short int ruch; /* if 0 -> is marked for moving. if 1 -> is not marked for moving */
	short int x;
	short int y;
	int numer;
	/*short int leci;  czy bomba jest zywa czy uspiona */
	short int zabija; /* czy moze zabic ludka czy nie(czyli: nie porusza sie) 0=zabija, 1=nie zabija. */
	/*plansza* pla; bomba musi umiec manipulowac plansza! */
};

struct Ludek 
{
	short int fanty; /* ile zebral */
	short int x;
	short int y;
};

struct Explosion
{
	short int y; /* CENTER of the explosion */
	short int x; /* CENTER of the explosion */
	short int valid; /* 0 = new, 1 = gone. */
	int what;
	explosion* next; /* or NULL */
};

struct Birds
{
	short int y;
	short int x;
	short int movey;
	short int movex;
};

void initscreen (void); /* Inicjalizacja ekranu terminala w ncurses */
void koniecgry (plansza* pla);
plansza* wczytajplansze(char* sciezka, int nrplanszy); /* wczytuje plansze z pliku */
void inicjujplansze(plansza* pla, short int lives, short int curlvl);
void wyswietlplansze(plansza* pla); /* wyswietla plansze na ekranie po wczytaniu */

void gravity(void* plaa); /* na razie robocza procedura. */
short int przesunb(plansza* pla, short int y, short int x); /* wektor[3] = {lewo, dol, prawo}; */

short int movegem(plansza* pla, short int y, short int x);

void mainloop(void* plaa);

short int checkdead(int x, int y, plansza* pla); /* sprawdza, czy jestem trupem. */
void koniecbomby(gravitable* ja); /* niszczy bombe */
void watekludka(void* deskryptor_ludka);
short int idx(plansza* pla, int x, int y); /* wymus==0 -> ruch bez wzgledu na to, czy pole jest wolne czy nie */
void inttochar(int liczba, char* output); /* converts int to char[4] */

void addexpl(plansza* pla, int y, int x, int what); /* adds an explosion to the list of pending explosions */
void showExplosions(plansza* pla); /* print pending explosions to the screen */
void delExplosions(plansza* pla); /* delete explosions from the screen */
void freeExplosions(plansza* pla); /* free memory */
void statusBar(short int howMuchToEat, short int fanty, short int lives, short int curlvl, short int died);
void fly(plansza* pla); /* bird! */
short int blowBird(plansza* pla, short int whichBird); /* do the bird explode? */
