/*		This code is GPL'ed !! See LICENSE
 *      ruchb.c
 *		This file contains routines for controlling gravity.
 */

#include "hdr.h"

void gravity(void* plaa)
{	
	plansza* pla = (plansza*) plaa;
	int i;
	int j;
		
	/* this is main loop - could be FASTER!! */ /* FIXME */
		
	for(j=22; j >= 0; j--)
		for(i=79; i >= 0; i--)
		{	
			if(pla->tab[j][i] == IS_STONE) /* tab[j][i] = tab[y][x] */
				i -= przesunb(pla, j, i);
			else if (pla->tab[j][i] == IS_GEM)
				i -= movegem(pla, j, i);
		}	
}

short int przesunb(plansza* pla, short int y, short int x)
{	
	gravitable* me = &(pla->tabOfGravs[pla->gravitables[y][x]]);
	short int direction = pla->direction;
	
	if(pla->tab[y+1][x] == IS_SPACE || pla->tab[y+1][x] == IS_EXPLOSION) /* under us is a hole... */
	{
		if(me->ruch == 1 || pla->tab[y+1][x] == IS_EXPLOSION)
			me->ruch = 0;
		else
		{
			me->zabija = 0;
			/* Move down */
			pla->tab[y+1][x] = IS_STONE;
			mvaddch(y+1, x, IS_STONE);
			mvaddch(y, x, IS_SPACE);
			pla->tab[y][x] = IS_SPACE;
			/* Tell others where i am */
			pla->gravitables[y][x] = -1;
			pla->gravitables[y+1][x] = me->numer;
		}
	}
	else if((pla->tab[y+1][x] == IS_PLAYER || pla->tab[y+1][x] == IS_GEM || pla->tab[y+1][x] == IS_EXIT) \
			&& me->zabija == 0)
	{
		mvaddch(y, x, IS_SPACE);
		pla->tab[y][x] = IS_SPACE; 
		addexpl(pla, y+1, x, IS_SPACE);
	}
	else if(pla->tab[y+1][x] == IS_BIRD && me->zabija == 0)
	{
		mvaddch(y, x, IS_SPACE);
		pla->tab[y][x] = IS_SPACE; 
		addexpl(pla, y+1, x, IS_GEM);
	}	
	else if(pla->tab[y][x+direction] == IS_SPACE && \
			pla->tab[y+1][x+direction] == IS_SPACE /*&& \
			pla->tab[y+1][x] != IS_PLAYER*/) /* fant cannot fall from your head! */
	{
		if(me->ruch == 1)
			me->ruch = 0;
		else
		{
			/* Move direction */
			pla->tab[y][x+direction] = IS_STONE;
			mvaddch(y, x+direction, IS_STONE);
			mvaddch(y, x, IS_SPACE);
			pla->tab[y][x] = IS_SPACE;
			/* Tell others where i am */
			pla->gravitables[y][x] = -1;
			pla->gravitables[y][x+direction] = me->numer;
			pla->direction *= -1;
			return 1; /* so we know we must jump, not to count this bomb 2nd time */
		}
	}
	else if(pla->tab[y][x-direction] == IS_SPACE && \
			pla->tab[y+1][x-direction] == IS_SPACE /*&& \
			pla->tab[y+1][x] != IS_PLAYER*/)
	{
		if(me->ruch == 1)
			me->ruch = 0;
		else
		{
			/* Move down */
			pla->tab[y][x-direction] = IS_STONE;
			mvaddch(y, x-direction, IS_STONE);
			mvaddch(y, x, IS_SPACE);
			pla->tab[y][x] = IS_SPACE;
			/* Tell others where i am */
			pla->gravitables[y][x] = -1;
			pla->gravitables[y][x-direction] = me->numer;
			pla->direction *= -1;
			return 1; /* so we know we must jump */
		}
	}
	else /* phew! we cannot move! */
	{
		me->ruch = 1;
		me->zabija = 1;
	}
	return 0;
}

short int checkdead(int x, int y, plansza* pla)
{
	if(pla->tab[y][x] == ((int)'*' | COLOR_PAIR(BUM) | A_BOLD)) return 0; //trup
	else return 1;
}

short int movegem(plansza* pla, short int y, short int x)
{
	gravitable* me = &(pla->tabOfGravs[pla->gravitables[y][x]]);
	short int direction = pla->direction;
	
	if(pla->tab[y+1][x] == IS_SPACE || pla->tab[y+1][x] == IS_EXPLOSION) /* under us is a hole... */
	{
		if(me->ruch == 1 || pla->tab[y+1][x] == IS_EXPLOSION)
			me->ruch = 0;
		else
		{
			me->zabija = 0;
			/* Move down */
			pla->tab[y+1][x] = IS_GEM;
			mvaddch(y+1, x, IS_GEM);
			mvaddch(y, x, IS_SPACE);
			pla->tab[y][x] = IS_SPACE;
			/* Tell others where i am */
			pla->gravitables[y][x] = -1;
			pla->gravitables[y+1][x] = me->numer;
		}
	}
	else if(pla->tab[y+1][x] == IS_PLAYER && me->zabija == 0)
	{
		mvaddch(y, x, IS_SPACE);
		pla->tab[y][x] = IS_SPACE; 
		addexpl(pla, y+1, x, IS_SPACE);
	}
	else if(pla->tab[y][x+direction] == IS_SPACE && \
			pla->tab[y+1][x+direction] == IS_SPACE /*&& \
			pla->tab[y+1][x] != IS_PLAYER*/) /* fant cannot fall from your head! */
	{
		if(me->ruch == 1)
			me->ruch = 0;
		else
		{
			/* Move direction */
			pla->tab[y][x+direction] = IS_GEM;
			mvaddch(y, x+direction, IS_GEM);
			mvaddch(y, x, IS_SPACE);
			pla->tab[y][x] = IS_SPACE;
			/* Tell others where i am */
			pla->gravitables[y][x] = -1;
			pla->gravitables[y][x+direction] = me->numer;
			pla->direction *= -1;
			return 1; /* so we know we must jump, not to count this bomb 2nd time */
		}
	}
	else if(pla->tab[y][x-direction] == IS_SPACE && \
			pla->tab[y+1][x-direction] == IS_SPACE /*&& \
			pla->tab[y+1][x] != IS_PLAYER*/)
	{
		if(me->ruch == 1)
			me->ruch = 0;
		else
		{
			/* Move down */
			pla->tab[y][x-direction] = IS_GEM;
			mvaddch(y, x-direction, IS_GEM);
			mvaddch(y, x, IS_SPACE);
			pla->tab[y][x] = IS_SPACE;
			/* Tell others where i am */
			pla->gravitables[y][x] = -1;
			pla->gravitables[y][x-direction] = me->numer;
			pla->direction *= -1;
			return 1; /* so we know we must jump */
		}
	}
	else /* phew! we cannot move! */
	{
		me->ruch = 1;
		me->zabija = 1;
	}
	return 0;
}
